searchNodes=[{"doc":"A library for modeling the internal state of a computer keyboard. See AFK.Keycode and AFK.Keymap to learn how to create keymaps with layers. Then see AFK.State to see how to initialize and manipulate the state.","ref":"AFK.html","title":"AFK","type":"module"},{"doc":"Defines a behaviour for converting an AFK.State struct into a binary USB HID report. Current implementations: AFK.HIDReport.SixKeyRollover","ref":"AFK.HIDReport.html","title":"AFK.HIDReport","type":"behaviour"},{"doc":"","ref":"AFK.HIDReport.html#c:hid_report/1","title":"AFK.HIDReport.hid_report/1","type":"callback"},{"doc":"Implements the AFK.HIDReport behaviour to produce a standard 6-key rollover USB keyboard HID report. The report is an 8-byte binary with the first byte being a bitmap of modifier keys that are currently active, the second byte being zero (reserved), and the following 6 bytes are the first 6 key scancodes that are active. Any additionally active keys are ignored in this report.","ref":"AFK.HIDReport.SixKeyRollover.html","title":"AFK.HIDReport.SixKeyRollover","type":"module"},{"doc":"A keycode represents a key that when pressed affects the keyboard state in some way. The currently supported keycode types are: AFK.Keycode.Key - A basic keyboard key AFK.Keycode.KeyLock - A key that allows locking other keys AFK.Keycode.Layer - A key that can activate other layers AFK.Keycode.Modifier - A basic keyboard modifier AFK.Keycode.None - A keycode that does nothing AFK.Keycode.Transparent - A key that is transparent to its layer","ref":"AFK.Keycode.html","title":"AFK.Keycode","type":"module"},{"doc":"","ref":"AFK.Keycode.html#t:t/0","title":"AFK.Keycode.t/0","type":"type"},{"doc":"","ref":"AFK.Keycode.html#t:with_scancode/0","title":"AFK.Keycode.with_scancode/0","type":"type"},{"doc":"Represents a basic keyboard keycode, like letters, numbers, etc. All standard keys on a keyboard except the modifiers can be represented by Key keycodes. The currently supported keys are key/0 .","ref":"AFK.Keycode.Key.html","title":"AFK.Keycode.Key","type":"module"},{"doc":"Creates a basic key keycode. Examples iex&gt; new ( :a ) % AFK.Keycode.Key { key : :a } iex&gt; new ( :up ) % AFK.Keycode.Key { key : :up }","ref":"AFK.Keycode.Key.html#new/1","title":"AFK.Keycode.Key.new/1","type":"function"},{"doc":"","ref":"AFK.Keycode.Key.html#t:key/0","title":"AFK.Keycode.Key.key/0","type":"type"},{"doc":"","ref":"AFK.Keycode.Key.html#t:t/0","title":"AFK.Keycode.Key.t/0","type":"type"},{"doc":"KeyLock allows you to lock any key as if you were holding it down. Pressing the KeyLock key first, and then any other key, will lock the second key as if it were being held down. Think of this like Caps Lock, but for any key.","ref":"AFK.Keycode.KeyLock.html","title":"AFK.Keycode.KeyLock","type":"module"},{"doc":"Creates a KeyLock keycode. Examples iex&gt; new ( ) % AFK.Keycode.KeyLock { }","ref":"AFK.Keycode.KeyLock.html#new/0","title":"AFK.Keycode.KeyLock.new/0","type":"function"},{"doc":"","ref":"AFK.Keycode.KeyLock.html#t:t/0","title":"AFK.Keycode.KeyLock.t/0","type":"type"},{"doc":"Represents a key that can activate other layers on and off in various ways. Layers can be activated in 3 ways: :hold - Temporarily activates a layer while being held :toggle - Toggles a layer on or off when pressed :default - Sets a layer as the default layer","ref":"AFK.Keycode.Layer.html","title":"AFK.Keycode.Layer","type":"module"},{"doc":"Creates a layer activation keycode. The valid types are: :hold - Activates a layer while being held :toggle - Toggles a layer on or off when pressed :default - Sets a layer as the default layer Examples iex&gt; new ( :hold , 1 ) % AFK.Keycode.Layer { layer : 1 , mode : :hold } iex&gt; new ( :hold , 2 ) % AFK.Keycode.Layer { layer : 2 , mode : :hold } iex&gt; new ( :toggle , 1 ) % AFK.Keycode.Layer { layer : 1 , mode : :toggle } iex&gt; new ( :default , 2 ) % AFK.Keycode.Layer { layer : 2 , mode : :default }","ref":"AFK.Keycode.Layer.html#new/2","title":"AFK.Keycode.Layer.new/2","type":"function"},{"doc":"","ref":"AFK.Keycode.Layer.html#t:layer/0","title":"AFK.Keycode.Layer.layer/0","type":"type"},{"doc":"","ref":"AFK.Keycode.Layer.html#t:mode/0","title":"AFK.Keycode.Layer.mode/0","type":"type"},{"doc":"","ref":"AFK.Keycode.Layer.html#t:t/0","title":"AFK.Keycode.Layer.t/0","type":"type"},{"doc":"MFA allows you to call arbitrary Elixir code from key presses.","ref":"AFK.Keycode.MFA.html","title":"AFK.Keycode.MFA","type":"module"},{"doc":"Creates an MFA keycode. Examples In this example, the keycode will call MyMod.my_func/0 when pressed, and nothing when released. iex&gt; new ( { MyMod , :my_func } ) % AFK.Keycode.MFA { pressed_mfa : { MyMod , :my_func } }","ref":"AFK.Keycode.MFA.html#new/2","title":"AFK.Keycode.MFA.new/2","type":"function"},{"doc":"","ref":"AFK.Keycode.MFA.html#t:mfargs/0","title":"AFK.Keycode.MFA.mfargs/0","type":"type"},{"doc":"","ref":"AFK.Keycode.MFA.html#t:t/0","title":"AFK.Keycode.MFA.t/0","type":"type"},{"doc":"Represents a basic modifier keycode, like control, shift, etc. All standard modifiers on a keyboard can be represented by Modifier keycodes. The currently supported modifiers are modifier/0 .","ref":"AFK.Keycode.Modifier.html","title":"AFK.Keycode.Modifier","type":"module"},{"doc":"Creates a basic modifier keycode. Examples iex&gt; new ( :left_control ) % AFK.Keycode.Modifier { modifier : :left_control } iex&gt; new ( :right_super ) % AFK.Keycode.Modifier { modifier : :right_super }","ref":"AFK.Keycode.Modifier.html#new/1","title":"AFK.Keycode.Modifier.new/1","type":"function"},{"doc":"","ref":"AFK.Keycode.Modifier.html#t:modifier/0","title":"AFK.Keycode.Modifier.modifier/0","type":"type"},{"doc":"","ref":"AFK.Keycode.Modifier.html#t:t/0","title":"AFK.Keycode.Modifier.t/0","type":"type"},{"doc":"Represents a key that does nothing when pressed.","ref":"AFK.Keycode.None.html","title":"AFK.Keycode.None","type":"module"},{"doc":"Creates a None keycode. Examples iex&gt; new ( ) % AFK.Keycode.None { }","ref":"AFK.Keycode.None.html#new/0","title":"AFK.Keycode.None.new/0","type":"function"},{"doc":"","ref":"AFK.Keycode.None.html#t:t/0","title":"AFK.Keycode.None.t/0","type":"type"},{"doc":"Represents a key that is transparent to its layer. Any key-press it registers falls to lower layers, of any.","ref":"AFK.Keycode.Transparent.html","title":"AFK.Keycode.Transparent","type":"module"},{"doc":"Creates a Transparent keycode. Examples iex&gt; new ( ) % AFK.Keycode.Transparent { }","ref":"AFK.Keycode.Transparent.html#new/0","title":"AFK.Keycode.Transparent.new/0","type":"function"},{"doc":"","ref":"AFK.Keycode.Transparent.html#t:t/0","title":"AFK.Keycode.Transparent.t/0","type":"type"},{"doc":"A keymap represents the virtual key layout of a keyboard. It can be made up of multiple layers that can be activated and deactivated by pressing AFK.Layer keycodes. A keymap just needs to be a list of maps, where each map is a mapping of physical key identifier (an atom), to an AFK.Keycode.Keycode . For example: [ # Layer 0 (default) %{ k001 : AFK.Keycode.Key . new ( :a ) , k002 : AFK.Keycode.Modifier . new ( :left_control ) , k003 : AFK.Keycode.Layer . new ( :hold , 1 ) , k004 : AFK.Keycode.Key . new ( :caps_lock ) } , # Layer 1 %{ k001 : AFK.Keycode.Key . new ( :z ) , k002 : AFK.Keycode.Modifier . new ( :right_super ) , k003 : AFK.Keycode.None . new ( ) , k004 : AFK.Keycode.Transparent . new ( ) } ]","ref":"AFK.Keymap.html","title":"AFK.Keymap","type":"module"},{"doc":"Loads a keymap from a file.","ref":"AFK.Keymap.html#load_from_file!/1","title":"AFK.Keymap.load_from_file!/1","type":"function"},{"doc":"Saves a keymap to a file.","ref":"AFK.Keymap.html#save_to_file!/2","title":"AFK.Keymap.save_to_file!/2","type":"function"},{"doc":"","ref":"AFK.Keymap.html#t:layer/0","title":"AFK.Keymap.layer/0","type":"type"},{"doc":"","ref":"AFK.Keymap.html#t:t/0","title":"AFK.Keymap.t/0","type":"type"},{"doc":"A GenServer process representing the current state of the keyboard. The process can effectively be thought of as a realtime stream manipulator. It receives key press and key release events (through press_key/2 and release_key/2 respectively) and transforms them into an outgoing event stream of HID reports. The process will send message to the given :event_receiver of the form {:hid_report, hid_report} .","ref":"AFK.State.html","title":"AFK.State","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"AFK.State.html#child_spec/1","title":"AFK.State.child_spec/1","type":"function"},{"doc":"Presses a key. The given key must not already be being pressed, otherwise the server will crash.","ref":"AFK.State.html#press_key/2","title":"AFK.State.press_key/2","type":"function"},{"doc":"Releases a key being pressed. The given key must be being pressed, otherwise the server will crash.","ref":"AFK.State.html#release_key/2","title":"AFK.State.release_key/2","type":"function"},{"doc":"Starts the state GenServer. The three required arguments (in the form of a keyword list) are: :event_receiver - A PID to send the HID reports to. :keymap - The keymap to use (see AFK.Keymap for details). :hid_report_mod - A module that implements the AFK.HIDReport behaviour.","ref":"AFK.State.html#start_link/2","title":"AFK.State.start_link/2","type":"function"},{"doc":"","ref":"AFK.State.html#t:args/0","title":"AFK.State.args/0","type":"type"},{"doc":"","ref":"AFK.State.html#t:t/0","title":"AFK.State.t/0","type":"type"},{"doc":"A library for modeling the internal state of a computer keyboard. It supports arbitrary layouts with any number of layers, and outputs a basic 6-key HID report byte string. Its intended use is to model the state for keyboard firmware.","ref":"readme.html","title":"README","type":"extras"},{"doc":"AFK can be installed by adding afk to your list of dependencies in mix.exs : def deps do [ { :afk , &quot;~&gt; 0.3&quot; } ] end","ref":"readme.html#installation","title":"README - Installation","type":"extras"},{"doc":"First, you define a keymap: keymap = [ # Layer 0 (default) %{ k001 : AFK.Keycode.Key . new ( :a ) , k002 : AFK.Keycode.Modifier . new ( :left_control ) , k003 : AFK.Keycode.Layer . new ( :hold , 1 ) , k004 : AFK.Keycode.Key . new ( :caps_lock ) } , # Layer 1 %{ k001 : AFK.Keycode.Key . new ( :z ) , k002 : AFK.Keycode.Modifier . new ( :right_super ) , k003 : AFK.Keycode.None . new ( ) , k004 : AFK.Keycode.Transparent . new ( ) } ] You can now start a state process using AFK.State.start_link/2 , by providing a keymap, an event receiver PID, and a module that implements the AFK.HIDReport behaviour. { :ok , state } = AFK.State . start_link ( keymap : keymap , event_receiver : self ( ) , hid_report_mod : AFK.HIDReport.SixKeyRollover ) AFK.State . press_key ( state , :k003 ) AFK.State . press_key ( state , :k002 ) AFK.State . press_key ( state , :k001 ) AFK.State . release_key ( state , :k002 ) # take a look at our process mailbox :erlang . process_info ( self ( ) , :messages ) # {:messages, # [ # hid_report: &lt;&lt;0, 0, 0, 0, 0, 0, 0, 0&gt;&gt;, # hid_report: &lt;&lt;128, 0, 0, 0, 0, 0, 0, 0&gt;&gt;, # hid_report: &lt;&lt;128, 0, 29, 0, 0, 0, 0, 0&gt;&gt;, # hid_report: &lt;&lt;0, 0, 29, 0, 0, 0, 0, 0&gt;&gt; # ]}","ref":"readme.html#basic-usage","title":"README - Basic Usage","type":"extras"},{"doc":"AFK provides a behaviour for defining how to convert the state into a HID report. Currently only a 6-key rollover implementation is provided, but an N-key rollover implementation would be a great addition. (Pull requests welcome!) It may eventually also support more complex interactions, such as sticky keys, macros, leader keys, etc. These features require a lot more thinking though, as they will require the state undergoing changes over time.","ref":"readme.html#future-features","title":"README - Future Features","type":"extras"},{"doc":"Documentation can be found at https://hexdocs.pm/afk .","ref":"readme.html#docs","title":"README - Docs","type":"extras"},{"doc":"Copyright &amp;copy; 2020 Nerves Keyboard group Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"LICENSE","type":"extras"}]